<template>
  <div id="project" class="container">
    <coscine-headline :headline="$t('subprojects')" />
    <div class="list">
      <b-card-group deck class="dashboard">
        <coscine-card
          :displayName="$t('addProject')"
          :imagePath="zusatzImage"
          :cardLink="openCreate()"
        />
        <coscine-card
          v-for="(project, index) in subProjects"
          :key="index"
          :displayName="project.displayName"
          :imagePath="projectImage"
          :cardLink="redirect(project)"
        />
      </b-card-group>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { LanguageUtil, GuidUtil, LinkUtil } from "@coscine/app-util";
import { SubProjectApi } from "@coscine/api-connection";
import { CoscineCard, CoscineHeadline } from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

import projectImagePath from "./assets/RWTH_Piktogramm_Projekte.png";
import zusatzImagePath from "./assets/RWTH_Piktogramm_Zusatzangebot.png";

let pathToAppJs = "";
if (document.currentScript !== undefined) {
  pathToAppJs = (document.currentScript as any).src as string;
}

export default Vue.extend({
  name: "project",
  components: {
    CoscineCard,
    CoscineHeadline,
  },
  data() {
    return {
      subProjects: [] as Array<unknown>,
      projectImage: "",
      zusatzImage: "",
    };
  },
  methods: {
    openCreate() {
      return LinkUtil.getProjectLink("CreateProject");
    },
    redirect(project: any) {
      return LinkUtil.getExternalProjectLink(project.slug.toLowerCase());
    },
  },
  created() {
    this.projectImage = LinkUtil.getScriptPath(pathToAppJs) + projectImagePath;
    this.zusatzImage = LinkUtil.getScriptPath(pathToAppJs) + zusatzImagePath;
    SubProjectApi.getSubProjects(GuidUtil.getProjectId(), (response: any) => {
      for (const datum of response.data) {
        this.subProjects.push(datum);
      }
    });
  },
});
</script>
